---
title: Export web and API operations as OpenAPI schemas
---

[Skip to content](#_top)

[API Reference](https://developers.cloudflare.com/api/typescript)

[API Gateway](https://developers.cloudflare.com/api/typescript/resources/api_gateway)

[Schemas](https://developers.cloudflare.com/api/typescript/resources/api_gateway/subresources/schemas)

Copy Markdown

Open in **Claude**Open in **ChatGPT**Open in **Cursor**

---

**Copy Markdown****View as Markdown**

# Export web and API operations as OpenAPI schemas

client.apiGateway.schemas.list(SchemaListParams {zone\_id, feature, host, include\_schema\_kind } params, RequestOptionsoptions?): [SchemaListResponse](<https://developers.cloudflare.com/api/typescript/resources/api_gateway#(resource)%20api_gateway.schemas%20%3E%20(model)%20schema_list_response%20%3E%20(schema)>) {schemas, timestamp }

GET/zones/{zone\_id}/api\_gateway/schemas

Returns tracked web and API operations and their feature configuration rendered as OpenAPI schemas.

##### Security

<details>

<summary>API Token</summary>



The preferred authorization scheme for interacting with the Cloudflare API. <a href="https://developers.cloudflare.com/fundamentals/api/get-started/create-token/">Create a token</a>.

**Example:**<code>Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY</code>

</details>

<details>

<summary>API Email + API Key</summary>



The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

**Example:**<code>X-Auth-Email: user@example.com</code>

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

**Example:**<code>X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194</code>

</details>

##### Accepted Permissions (at least one required)

`Account API Gateway``Account API Gateway Read``Domain API Gateway``Domain API Gateway Read`

##### ParametersExpand Collapse

<details>

<summary>

params: SchemaListParams {zone\_id, feature, host, include\_schema\_kind }

</summary>

zone\_id: string

Path param: Identifier.

maxLength32

<a href="#(resource)%20api_gateway.schemas%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20zone_id">Link to this property</a>

<details>

<summary>

feature?: Array&lt;"thresholds"| "parameter\_schemas"| "schema\_info"| "confidence\_intervals"&gt;

Query param: Add feature(s) to the results. The feature name that is given here corresponds to the resulting feature object. Have a look at the top-level object description for more details on the specific meaning.

</summary>

One of the following:

"thresholds"

<a href="#(resource)%20api_gateway.schemas%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20feature%20%3E%20(schema)%20%3E%20(items)%20%3E%20(member)%200">Link to this property</a>

"parameter\_schemas"

<a href="#(resource)%20api_gateway.schemas%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20feature%20%3E%20(schema)%20%3E%20(items)%20%3E%20(member)%201">Link to this property</a>

"schema\_info"

<a href="#(resource)%20api_gateway.schemas%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20feature%20%3E%20(schema)%20%3E%20(items)%20%3E%20(member)%202">Link to this property</a>

"confidence\_intervals"

<a href="#(resource)%20api_gateway.schemas%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20feature%20%3E%20(schema)%20%3E%20(items)%20%3E%20(member)%203">Link to this property</a>

</details>

<a href="#(resource)%20api_gateway.schemas%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20feature">Link to this property</a>

host?: Array&lt;string&gt;

Query param: Receive schema only for the given host(s).

<a href="#(resource)%20api_gateway.schemas%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20host">Link to this property</a>

include\_schema\_kind?: Array&lt;"learned"&gt;

Query param: Schema kinds to include in exported OpenAPI schemas.

<a href="#(resource)%20api_gateway.schemas%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20include_schema_kind">Link to this property</a>

</details>

[Link to this property](<#(resource)%20api_gateway.schemas%20%3E%20(method)%20list%20%3E%20(params)%20default>)

##### ReturnsExpand Collapse

<details>

<summary>

SchemaListResponse {schemas, timestamp }

</summary>

schemas?: Array&lt;unknown&gt;

<a href="#(resource)%20api_gateway.schemas%20%3E%20(model)%20schema_list_response%20%3E%20(schema)%20%3E%20(property)%20schemas">Link to this property</a>

timestamp?: string

<a href="#(resource)%20api_gateway.schemas%20%3E%20(model)%20schema_list_response%20%3E%20(schema)%20%3E%20(property)%20timestamp">Link to this property</a>

</details>

[Link to this property](<#(resource)%20api_gateway.schemas%20%3E%20(model)%20schema_list_response%20%3E%20(schema)>)

### Export web and API operations as OpenAPI schemas

TypeScript

HTTPTypeScriptPythonGoTerraform

```
import Cloudflare from 'cloudflare';

const client = new Cloudflare({
  apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted
});

const schemas = await client.apiGateway.schemas.list({
  zone_id: '023e105f4ecef8ad9ca31a8372d0c353',
});

console.log(schemas.schemas);
```

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": {
    "schemas": [
      {
        "info": {
          "title": "OpenAPI JSON schema for www.example.com",
          "version": "1.0"
        },
        "openapi": "3.0.0",
        "paths": {
          "... Further paths ...": {},
          "/api/v1/users/{var1}": {
            "get": {
              "parameters": [
                {
                  "name": "var1",
                  "in": "path",
                  "required": true,
                  "schema": {
                    "type": "string"
                  }
                }
              ]
            }
          }
        },
        "servers": [
          {
            "url": "www.example.com"
          }
        ]
      }
    ],
    "timestamp": "timestamp"
  },
  "success": true
}
```

##### Returns Examples

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": {
    "schemas": [
      {
        "info": {
          "title": "OpenAPI JSON schema for www.example.com",
          "version": "1.0"
        },
        "openapi": "3.0.0",
        "paths": {
          "... Further paths ...": {},
          "/api/v1/users/{var1}": {
            "get": {
              "parameters": [
                {
                  "name": "var1",
                  "in": "path",
                  "required": true,
                  "schema": {
                    "type": "string"
                  }
                }
              ]
            }
          }
        },
        "servers": [
          {
            "url": "www.example.com"
          }
        ]
      }
    ],
    "timestamp": "timestamp"
  },
  "success": true
}
```